# Contributing

## Contributors

Anyone who has been contributed to the repository by submitting a pull-request and have it reviewed, accepted, and merged by committers is a contributor.

Each contributor should comply with the [Code of Conduct](https://github.com/nnstreamer/nntrainer/blob/main/CODE_OF_CONDUCT.md), this document (CONTRIBUTING.md), and [the Linux Foundation's policies](http://lfprojects.org/policies/).

Every contributor is able and encouraged to review codes and to participate in other developmental activities.



## Committers

A committer is responsible for reviewing incoming pull-requests and is able to reject or approve pull requests. Note that contributors may review pull-requests, but they cannot reject it or vote for approval.

A contributor may become a committer with approvals of more than half of the committers. 

A committer may be retired by approvals of more than half of the committers.

Each committer is also a contributor and should comply with the [Code of Conduct](https://github.com/nnstreamer/nntrainer/blob/main/CODE_OF_CONDUCT.md), this document (CONTRIBUTING.md), and [the Linux Foundation's policies](http://lfprojects.org/policies/).

The committers are:

* Jijoong Moon @jijoongmoon :beer: (maintainer)
* MyungJoo Ham @myungjoo :beer:
* Geunsik Lim @leemgs :beer:
* Jaeyun Jung @jaeyun-jung :beer:
* Sangjung Woo @again4you :beer:
* Wook Song @wooksong :beer:
* Dongju Chae @dongju-chae :beer:
* HyoungJoo Ahn @helloahn :beer:
* Parichay Kapoor @kparichay :beer:
* Gichan Jang @gichan-jang
* Yongjoo Ahn @anyj0527
* Jihoon Lee @zhoonit


## Merging a pull-request

[How to Contribute # Merge Criteria](docs/contributing.md#merge-criteria) describes how a pull-request may be merged or rejected by committers.

In the above list, committers with :beer: have merging privilege.

Granting or revoking merging privileges require the same procedure of electing or retiring a committer.

Each sub-project may have its own [Maintainers](MAINTAINERS.md#maintainer) in the sub-project.


# Links to related information

## Contributing

See [How to Contribute](docs/contributing.md) for information about coding styles, making pull requests, and more.

## Developers

- See [Getting Started](docs/getting-started.md) for information about building this software.
- See [How to Run Examples](docs/how-to-run-examples.md) for information about building and running examples applications.
- See [How to Use Testcases](docs/how-to-use-testcases.md) for information about running test cases and writing ones.
